VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWndTabble"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Public Enum WndType
    WT_MAIN
    WT_ARRAY
    WT_UDT
    WT_BLOCK
End Enum
Private Type tColumn
    WidthColumn As Long
    Caption As String
End Type
Private Type tRow
    PinIn As Boolean
    PinOut As Boolean
    BackColor As String
End Type
Dim mType As WndType, mCont As PictureBox, mData() As String, mCol&, mRow&, mColWidth() As tColumn, mRowSet() As tRow, mRowHeight&
Dim mTop&, mLeft&, mTitle$
Dim tDC&, sDC&, tBmp&, sBmp&, otBmp&, osBmp&, GDIInit As Boolean
Dim tabbleFnt As IFont, headFnt As IFont, tblFnt&, hedFnt&
Public Property Let Title(ByVal Caption$)
    mTitle = Caption$
End Property
Public Property Get Title$()
    Title = mTitle
End Property
Public Property Set TabbleFont(Fnt As IFont)
    Set tabbleFnt = Nothing: Set headFnt = Nothing
    Fnt.Clone tabbleFnt
    Fnt.Clone headFnt
    headFnt.Bold = True
End Property
Public Property Get TabbleFont() As StdFont
    Set TabbleFont = tabbleFnt
End Property
Public Property Let Top(ByVal Position&)
    mTop = Position
End Property
Public Property Get Top&()
    Top = mTop
End Property
Public Property Let Left(ByVal Position&)
    mLeft = Position
End Property
Public Property Get Left&()
    Left = mLeft
End Property
Public Property Set Container(Prnt As PictureBox)
    Set mCont = Prnt
    If tblFnt& = 0 Then Set Me.TabbleFont = mCont.Font
    SetRowHeight
    GDIInit = False
End Property
Public Property Get Container() As PictureBox
    Set Container = mCont
End Property
Public Property Let TypeWindow(ByVal Wnd As WndType)
    mType = Wnd
End Property
Public Property Get TypeWindow() As WndType
    TypeWindow = mType
End Property
Public Property Let Column(ByVal Count&)
    mCol = Count&
    ChangeArrayData
    GDIInit = False
End Property
Public Property Get Column&()
    Column& = mCol
End Property
Public Property Let Row(ByVal Count&)
    mRow = Count&
    ChangeArrayData
    GDIInit = False
End Property
Public Property Get Row&()
    Row& = mRow
End Property
Public Property Get WidthWindow&()
    Dim N&
    For N = 1 To mCol
        WidthWindow& = WidthWindow& + mColWidth(N).WidthColumn
    Next
    WidthWindow& = WidthWindow& + 1
End Property
Public Property Get HeightWindow&()
    HeightWindow& = mRowHeight * (mRow + 1) + 26
End Property

Public Function ColumnSet(ByVal Index&, ByVal Caption$, ByVal Width&) As Boolean
    Index = Index + 1 ' Set as 0
    If Index > UBound(mColWidth) Then MsgBox "Subscript out of range in columns", vbCritical: Exit Function
    mColWidth(Index).Caption = Caption: mColWidth(Index).WidthColumn = Width: ColumnSet = True: GDIInit = False
End Function
Public Function ColumnWidth&(ByVal Index&)
    Index = Index + 1 ' Set as 0
    If Index > UBound(mColWidth) Then MsgBox "Subscript out of range in columns", vbCritical: Exit Function
    ColumnWidth& = mColWidth(Index).WidthColumn
End Function
Public Function ColumnCaption&(ByVal Index&)
    Index = Index + 1 ' Set as 0
    If Index > UBound(mColWidth) Then MsgBox "Subscript out of range in columns", vbCritical: Exit Function
    ColumnWidth& = mColWidth(Index).Caption
End Function
Public Sub ColumnClear()
    ReDim mColWidth(mCol): GDIInit = False
End Sub
Public Function RowSet(ByVal Index&, ByVal PinIn As Boolean, ByVal PinOut As Boolean, ByVal BackColor&) As Boolean
    Index = Index + 1 ' Set as 0
    If Index > mRow Then MsgBox "Subscript out of range in row", vbCritical: Exit Function
    mRowSet(Index).BackColor = BackColor: mRowSet(Index).PinIn = PinIn: mRowSet(Index).PinOut = PinOut: RowSet = True: GDIInit = False
End Function
Public Function RowPinIn(ByVal Index&) As Boolean
    Index = Index + 1 ' Set as 0
    If Index > mRow Then MsgBox "Subscript out of range in row", vbCritical: Exit Function
    RowPinIn = mRowSet(Index).PinIn
End Function
Public Function RowPinOut(ByVal Index&) As Boolean
    Index = Index + 1 ' Set as 0
    If Index > mRow Then MsgBox "Subscript out of range in row", vbCritical: Exit Function
    RowPinOut = mRowSet(Index).PinOut
End Function
Public Function RowBackColor&(ByVal Index&)
    Index = Index + 1 ' Set as 0
    If Index > mRow Then MsgBox "Subscript out of range in row", vbCritical: Exit Function
    RowBackColor& = mRowSet(Index).BackColor
End Function
Public Sub RowClear()
    ReDim mRowSet(mRow): GDIInit = False
End Sub
Public Function ItemSet(ByVal Col&, ByVal Row&, ByVal Caption$) As Boolean
    Col = Col + 1: Row = Row + 1 ' Set as 0
    If Col > mCol Or Row > mRow Then MsgBox "Subscript out of range in item", vbCritical: Exit Function
    mData(Col, Row) = Caption: ItemSet = True
End Function
Public Function ItemCaption$(ByVal Col&, ByVal Row&)
    Col = Col + 1: Row = Row + 1 ' Set as 0
    If Col > mCol Or Row > mRow Then MsgBox "Subscript out of range in item", vbCritical: Exit Function
    ItemCaption$ = mData(Col, Row)
End Function
Public Sub ItemClear()
    ReDim mRowSet(mCol, mRow)
End Sub
Public Sub DrawWindow()
    Dim W&, H&, oImg&, CtX&, CtY&, X&, Y&, RC As RECT, oFnt&
    Dim cPen&, cBrsh&, cTxt&, pIdx&
    If mCont Is Nothing Or mCol = 0 Then Exit Sub
    If Not GDIInit Then CreateBitmapForGDI
    Select Case mType
    Case WT_MAIN, WT_ARRAY, WT_UDT
        ' Draw Header
        If mType = WT_ARRAY Then pIdx = 2: cBrsh = &HD4B0BB: cPen = &H775549: cTxt = &HFFFFFF
        If mType = WT_MAIN Then pIdx = 1: cBrsh = &HC7DBAA: cPen = &H6E8F1E: cTxt = &H648096
        If mType = WT_UDT Then pIdx = 3: cBrsh = &H8CC7FC: cPen = &H366CBF: cTxt = &H3DEB
        W = Me.WidthWindow: H = Me.HeightWindow
        SetDCPenColor tDC, cPen: SetDCBrushColor tDC, vbWhite: SetTextColor tDC, &H425995
        Rectangle tDC, 0, 0, W, 26: oImg& = SelectObject(sDC, frmMain.imlWnd.ListImages(pIdx).Picture.Handle)
        StretchBlt tDC, 1, 1, W - 2, 24, sDC, 0, 0, 1, 24, vbSrcCopy
        SelectObject sDC, oImg: RC.Left = 5: RC.Top = 0: RC.Bottom = 26: RC.Right = W
        oFnt = SelectObject(tDC, headFnt.hFont): DrawText tDC, mTitle, Len(mTitle), RC, DT_VCENTER Or DT_SINGLELINE Or DT_END_ELLIPSIS
        'Draw Column
        X = 0: Y = 26 + mRowHeight: SetDCBrushColor tDC, cBrsh: SelectObject tDC, tabbleFnt.hFont: SetTextColor tDC, cTxt
        For CtX = 1 To mCol
            Rectangle tDC, X, 25, X + mColWidth(CtX).WidthColumn + 1, Y
            RC.Left = X + 1: RC.Top = 27: RC.Right = X + mColWidth(CtX).WidthColumn: RC.Bottom = Y
            DrawText tDC, mColWidth(CtX).Caption, Len(mColWidth(CtX).Caption), RC, DT_END_ELLIPSIS
            X = X + mColWidth(CtX).WidthColumn
        Next
        'Draw tabble
        X = 0: Y = Y - 1
        SetDCBrushColor tDC, &HFFFFFF: SetTextColor tDC, &H0
        For CtY = 1 To mRow: For CtX = 1 To mCol
            Rectangle tDC, X, Y, X + mColWidth(CtX).WidthColumn + 1, Y + mRowHeight + 1
            RC.Left = X + 1: RC.Top = Y: RC.Right = X + mColWidth(CtX).WidthColumn: RC.Bottom = Y + mRowHeight
            DrawText tDC, mData(CtX, CtY), Len(mData(CtX, CtY)), RC, DT_END_ELLIPSIS
            X = X + mColWidth(CtX).WidthColumn
        Next: X = 0: Y = Y + mRowHeight: Next
        SelectObject tDC, oFnt
    End Select
    BitBlt mCont.hdc, mTop, mLeft, W, H, tDC, 0, 0, vbSrcCopy
End Sub
Private Function CreateBitmapForGDI() As Boolean
    Dim W&, H&
    If mCont Is Nothing Then Exit Function
    W = Me.WidthWindow: H = Me.HeightWindow
    If W = 0 Or H = 0 Then Exit Function
    GDIInit = True
    If tDC = 0 Then
        tDC = CreateCompatibleDC(mCont.hdc): SetBkMode tDC, BS_TRANSPARENT
    End If
    If sDC = 0 Then sDC = CreateCompatibleDC(mCont.hdc): SetBkMode sDC, BS_TRANSPARENT
    If tBmp <> 0 Then SelectObject tDC, otBmp: DeleteObject tBmp
    If sBmp <> 0 Then SelectObject sDC, osBmp: DeleteObject sBmp
    SelectObject tDC, GetStockObject(DC_PEN)
    SelectObject tDC, GetStockObject(DC_BRUSH)
    tBmp = CreateCompatibleBitmap(mCont.hdc, W, H): otBmp = SelectObject(tDC, tBmp)
    sBmp = CreateCompatibleBitmap(mCont.hdc, W, H): osBmp = SelectObject(sDC, sBmp)
End Function
Private Sub SetRowHeight()
    If mCont Is Nothing Then Exit Sub
    mRowHeight = mCont.TextHeight("A"): mCont.ScaleMode = vbPixels
End Sub
Private Sub ChangeArrayData()
    ReDim mRowSet(mRow)
    ReDim mColWidth(mCol)
    ReDim mData(mCol, mRow)
End Sub
Private Sub Class_Initialize()
    ReDim mRowSet(0)
    ReDim mColWidth(0)
    ReDim mData(0, 0)
    mTitle = "Window class"
End Sub
Private Sub Class_Terminate()
    If tDC <> 0 Then DeleteDC (tDC)
    If sDC <> 0 Then DeleteDC (sDC)
    Set tabbleFnt = Nothing: Set headFnt = Nothing
    If tBmp <> 0 Then DeleteObject tBmp
    If sBmp <> 0 Then DeleteObject sBmp
End Sub
